﻿using GrapeCity.Windows.SpreadSheet.Data;
using GrapeCity.Windows.SpreadSheet.UI;
using Microsoft.Web.WebView2.Wpf;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Path = System.IO.Path;

namespace BorderDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly PrintDialog printDialog = new PrintDialog();
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.gcSpreadSheet1.Workbook.VerticalScrollBarVisibility = ScrollBarVisibility.Hidden;
            this.gcSpreadSheet1.Workbook.HorizontalScrollBarVisibility = ScrollBarVisibility.Hidden;
            this.gcSpreadSheet1.TabStripVisibility = Visibility.Collapsed;

            this.gcSpreadSheet1.ActiveSheet.ColumnHeader.IsVisible = false;
            this.gcSpreadSheet1.ActiveSheet.RowHeader.IsVisible = false;


            GrapeCity.Windows.SpreadSheet.Data.CellRange r;
            r = new GrapeCity.Windows.SpreadSheet.Data.CellRange(0, 0, 3, 3);
            gcSpreadSheet1.Sheets[0].SetBorder(r, GrapeCity.Windows.SpreadSheet.Data.SheetArea.Cells, new GrapeCity.Windows.SpreadSheet.Data.BorderLine(Colors.Blue, BorderLineStyle.Double), GrapeCity.Windows.SpreadSheet.Data.SetBorderOptions.All);


        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {


            string fileName;
            fileName = "d:\\test" + DateTime.Now.Ticks + ".pdf";
            System.IO.Stream stream;
            stream = System.IO.File.Create(fileName);

            gcSpreadSheet1.Workbook.Name = "WorkBook";
            gcSpreadSheet1.Sheets[0].Name = "Sheet 0";
            GrapeCity.Windows.SpreadSheet.Data.PrintInfo printtest;
            printtest = gcSpreadSheet1.Sheets[0].PrintInfo;
            printtest.FooterCenter = "This is Page &P";
            printtest.HeaderLeft = "&KFFFF00Color &KFF0000RedColor";
            printtest.BestFitColumns = true;
            printtest.UseMax = true;
            printtest.ShowBorder = false;

            GrapeCity.Windows.SpreadSheet.Data.PdfExportSettings test;
            test = new GrapeCity.Windows.SpreadSheet.Data.PdfExportSettings();
            test.Title = "Print PDF";
            test.Author = "GrapeCity, Inc.";
            test.DisplayDocTitle = true;
            test.FitWindow = true;
            gcSpreadSheet1.SavePdf(stream, test, 0);
            stream.Close();

            Process.Start(fileName);
        }


        private async void Button_Click2_Edge(object sender, RoutedEventArgs e)
        {
            GrapeCity.Windows.SpreadSheet.Data.PrintInfo printset = new GrapeCity.Windows.SpreadSheet.Data.PrintInfo();
            printset.FitPagesTall = 1;
            printset.FitPagesWide = 1;
            printset.ShowBorder = false;
            printset.ShowColumnHeader = GrapeCity.Windows.SpreadSheet.Data.VisibilityType.Hide;
            printset.ShowRowHeader = GrapeCity.Windows.SpreadSheet.Data.VisibilityType.Hide;
            printset.ShowGridLine = false;

            gcSpreadSheet1.Sheets[0].PrintInfo = printset;
            var fileName = Path.Combine(Path.GetTempPath(), DateTime.Now.Ticks + ".pdf");
            gcSpreadSheet1.SavePdf(fileName);

            IsEnabled = false;
            try
            {
                var edgeBrowser = new WebView2();
                var edgeWindow = new Window { Content = edgeBrowser };
                edgeWindow.Show();
                await edgeBrowser.EnsureCoreWebView2Async();
                edgeBrowser.CoreWebView2.Navigate(fileName);
                await edgeBrowser.CoreWebView2.ExecuteScriptAsync("window.print()");
                edgeWindow.Hide();
                edgeWindow.ShowDialog();
            }
            finally
            {
                IsEnabled = true;
            }
        }
    }
}
